﻿using curring_funcs;
using currying_in_net;
#pragma warning disable CS8974 // Converting method group to non-delegate type

Output.ShowType(Functions.f1, "Type(f1)");
Output.ShowType(Functions.f1p1, "Type(f1p1)");
Output.ShowType(Functions.f1p2, "Type(f1p2)");
var f1 = Functions.f1;
Output.ShowType(f1.Apply(1.0), "Type(f1(1.0))");

Output.ShowType(Functions.f2, "Type(f2)");
Output.ShowType(Functions.f2p, "Type(f2p)");
Output.ShowType(((Func<double, double, double>)Functions.f2).Apply(1.0), "Type(f2(1.0))");

var add = (double x1, double x2) => x1 + x2;
Output.ShowType(add, "Type(add)");
Output.ShowType(add.Apply(1.0), "Type(Add(1.0))");

Console.WriteLine();

Output.ShowValue(Functions.f1(1.0, 2.0), "f1(1.0, 2.0)");
Output.ShowValue(Functions.f1p1.Invoke(2.0), "f1p1(2.0)");
Output.ShowValue(Functions.f1p2(2.0), "f1p2(2.0)");
Output.ShowValue(f1.Apply(1.0)(2.0), "f1(1.0)(2.0)");

Output.ShowValue(add(1.0, 2.0), "add(1.0, 2.0)");
Output.ShowValue(add.Apply(1.0)(2.0), "add(1.0)(2.0)");

Output.ShowValue(Functions.f2(1.0, 2.0), "f2(1.0, 2.0)");
Output.ShowValue(Functions.f2p(2.0), "f2p(2.0)");
Output.ShowValue(((Func<double, double, double>)Functions.f2).Apply(1.0)(2.0), "f2(1.0)(2.0)");